<template>
    <div class="snackbar-msg" :class="{ 'snackbar-msg-hiding': hiding }">
        <div class="snackbar-msg-content">
            <span class="snackbar-msg-text">{{ msgData.text }}</span>
            <button @click="hiding = true" class="snackbar-msg-close">x</button>
        </div>
    </div>
</template>

<script>
import { mapMutations, mapState } from "vuex";

export default {
    name: "SnackbarMsg",
    data: () => ({
        hiding: false,
        hidingTime: 500,
    }),
    props: {
        msgData: { type: Object, default: () => ({}) },
    },
    methods: {
        ...mapMutations("snackbar", ["removeMsg"]),
    },
    computed: {
        ...mapState("snackbar", ["msgDelay"]),
    },
    mounted() {
        const timeout = setTimeout(() => {
            this.hiding = true;

            clearTimeout(timeout);
        }, this.msgDelay);
    },
    watch: {
        hiding(value) {
            if (value) {
                const animTimeout = setTimeout(() => {
                    this.removeMsg(this.msgData.id);
                    clearTimeout(animTimeout);
                }, this.hidingTime);
            }
        },
    },
};
</script>

<style scoped>
.snackbar-msg {
    background-color: powderblue;

    animation-timing-function: ease-out;
    animation-name: show;
    animation-duration: 200ms;
    animation-fill-mode: forwards;
}
.snackbar-msg-content {
    height: 4rem;
    display: flex;
    align-items: center;
    justify-content: center;
    position: relative;
}

.snackbar-msg-hiding {
    animation-iteration-count: 1;
    animation-fill-mode: forwards;
    animation-name: hiding;
    animation-timing-function: ease-in-out;
    animation-duration: 500ms;
    overflow: hidden;
}

.snackbar-msg-close {
    position: absolute;
    right: 0;
    top: 0;
}

.snackbar-msg-text {
    padding: 2rem;
}

@keyframes show {
    0% {
        opacity: 0;
    }

    100% {
        opacity: 1;
    }
}

@keyframes hiding {
    0% {
        opacity: 1;
        height: 4rem;
    }

    100% {
        opacity: 0;
        height: 0;
    }
}
</style>
